//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "CpkKeyImptDlgs.h"
#include "Cyberpunk.h"
#include "pgpmail.h" // NoNameYet macro
#include "pgpfiles.h"
#include "Global.h"
#include "helpdlgs.h"
#include "View.h"
//---------------------------------------------------------------------------
#pragma link "MixKeyImptDlgs"
#pragma resource "*.dfm"
TCpkKeyImptDlg *CpkKeyImptDlg;
const AnsiString CpkNoKeysFoundAtAll = "...NO KEYS FOUND AT ALL!";
const AnsiString CpkLoading = "Loading...";
//---------------------------------------------------------------------------
bool __fastcall ImportCyberpunkKeys(TForm *Owner, TCpkKeyList *keylist,
   TCpkKeyList *ImpKeys, TCpkKeyList *DupKeys, AnsiString &ImportDir)
{
   CpkKeyImptDlg = new TCpkKeyImptDlg(Owner,keylist,ImpKeys,DupKeys,ImportDir);
   CpkKeyImptDlg->ShowModal();
   bool ok = CpkKeyImptDlg->ModalResult==mrOk &&
      (ImpKeys->Count || DupKeys->Count);
   delete CpkKeyImptDlg;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyImptDlg::TCpkKeyImptDlg(TComponent* Owner)
  : TMixKeyImptDlg(Owner)
{
   // unused
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyImptDlg::TCpkKeyImptDlg(TComponent* Owner, TMixKeyList *Keylist,
   TMixKeyList *ImpKeys, TMixKeyList *DupKeys, AnsiString &ImportDir)
   : TMixKeyImptDlg(Owner)
{
   // unused
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyImptDlg::TCpkKeyImptDlg(TComponent* Owner, TCpkKeyList *Keylist,
   TCpkKeyList *ImpKeys, TCpkKeyList *DupKeys, AnsiString &ImportDir)
   : TMixKeyImptDlg(Owner)
{
   CenterDialog(this);
   impdir = &ImportDir;
   OpenDialog->InitialDir = *impdir;
   OpenDialog->Filter = "Cyberpunk key files (*.asc)|*.asc|All files (*.*)|*.*";
   OpenDialog->DefaultExt = ".asc";
   OpenDialog->FileName = "";
   ComboBox1->Items->Text = "Import Keys to Pubring.asc";
   ComboBox1->ItemIndex = 0;
   keylist = Keylist;
   implist = ImpKeys;
   implist->Clear();
   duplist = DupKeys;
   duplist->Clear();
   dislist = new TCpkKeyList();
   cap = Caption;
   nokeysfoundatall = CpkNoKeysFoundAtAll;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyImptDlg::ImportKeys(AnsiString Name, AnsiString Ascii)
{
   implist->Clear();
   duplist->Clear();
   dislist->Clear();
   RichEdit1->Clear();
   Caption = "";

   AnsiString s,cshort,curdesc,desc,keytext,orglines=Ascii;
   TStringList *key = new TStringList();
   TStringList *keys = new TStringList();
   ImportBtn->Enabled = false;

   keys->Text = Ascii;
   for (int i=0; i<keys->Count; i++)
   {
      if (keys->Strings[i]=="- "+BeginPgpPubKeyBlock) keys->Strings[i] = BeginPgpPubKeyBlock; else
      if (keys->Strings[i]=="- "+EndPgpPubKeyBlock) keys->Strings[i] = EndPgpPubKeyBlock;
   }
   while (keys->Count && keys->Strings[0]!=BeginPgpPubKeyBlock)
      keys->Delete(0);
   while (keys->Count && keys->Strings[keys->Count-1]!=EndPgpPubKeyBlock)
      keys->Delete(keys->Count-1);

   CpkBlockToKeysFull(keys);

   SetRedraw(Panel1,0);
   while (CpkGetNextKey(desc,key,keys)) // in cyberpunk.cpp
   {
      //if (desc.Pos(NoNameYet)==1) continue;

      bool dis=false,dup=false;
      // is the key already in type2
      if (keylist->IndexOf(desc)>=0) //|| probs->IndexOf(desc)>=0)
      {
         dislist->AddKey(desc,key);
         dis = true;
         //discnt++;
      }
      // No? Is the remailer shortname in type2
      if (!dis)
      {
         cshort = GetToken(0,desc," ");
         for (int i=0; i<keylist->Count; i++)
         {
            if (cshort==GetToken(0,keylist->Strings[i]," "))
            {
               duplist->AddKey(desc,key);
               dup = true;
               //dupcnt++;
               break;
            }
         }
      }
      // if neither above this is a new key
      if (!dis && !dup)
      {
         implist->AddKey(desc,key);
         //newcnt++;
      }
   }

   ListBox1->Clear();
   if (implist->Count)
   {
      for (int i=0; i<implist->Count; i++)
         ListBox1->Items->Add(implist->Strings[i]);
   }
   if (duplist->Count)
   {
      for (int i=0; i<duplist->Count; i++)
         ListBox1->Items->Add(duplist->Strings[i]);
   }
   if (ListBox1->Items->Count)
   {
      for (int i=0; i<ListBox1->Items->Count; i++)
         ListBox1->Selected[i] = true;
      ImportBtn->Enabled = true;
      ListBox1->BringToFront();
      ListBox1->TopIndex = 0;
   }
   else if (dislist->Count) RichEdit1->Lines->Add(Name+"...NO NEW KEYS");
   else RichEdit1->Lines->Add(Name+nokeysfoundatall);

   while (flash<4) AppProcessMessages();
   Timer1->Enabled = false;

   if (!ImportBtn->Enabled)
   {
      RichEdit1->Enabled = true;
      RichEdit1->BringToFront();
   }

   int total=implist->Count+duplist->Count;
   Caption = cap+"..."+s(total)+" key"+(total==1?"":"s");
   SetRedraw(Panel1,1);
   delete keys;
   delete key;
   MyBeep(MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyImptDlg::HelpBtnClick(TObject *Sender)
{
   OpenHelp("CyberpunkKeysImp","Cyberpunk PGP Keys","");
}
//---------------------------------------------------------------------------


